class Swarm {
  float centerX;
  float centerY;
  float radius;
  int size;
  Point[] points;

//----------------------------------------------------------------------------  
  
  Swarm (float newCenterX, float newCenterY, int newSize, float newRadius) {
     centerX = newCenterX;
     centerY = newCenterY;
     size = newSize;
     radius = newRadius;
     
     points = new Point[size];
     for (int i = 0; i < size; i++) {

//        float newX = centerX + random(radius);
//        float newY = centerY + random(radius);

       
        float angle = random(TWO_PI);
  
        float newX = centerX + random(radius) * cos(angle);
        float newY = centerY + random(radius) * sin(angle);

        points[i] = new Point(newX, newY); 
     }
          
  }
  
//----------------------------------------------------------------------------  
  
  void showSwarm () {
    for (int i = 0; i < size; i++) {
      points[i].showPoint();
    }    
  }
  
//----------------------------------------------------------------------------  
  
}
