PFont f, f1, pixel;
int x, y, step, t;
float fps, nSec, stepTime;
Nodo n1, n2;
boolean vis = true;
int numNodos;
Nodo[] nodos;
String numero;

//****************************************************************************

void setup( )
{
  size(800, 600);
  fps = 50;

  
  t = 0;
  stepTime = nSec;

  f = createFont("Arial", 16,true);
  f1 = createFont("Arial", 10,true);
  
  numNodos = 2;
  
  pixel = loadFont("pixel.vlw");
  nodos = new Nodo[numNodos];
  textFont (pixel, 8);
  textAlign(CENTER);
  ellipseMode(CENTER);
  smooth();
  
  
  numero = nfs(0, 0); // transforme 'i' en un string con cero decimal
  nodos[0] = new Nodo(200,200, numero);

  numero = nfs(1, 0); // transforme 'i' en un string con cero decimal
  nodos[1] = new Nodo(300,300, numero);
  
  step = 1;

}

//****************************************************************************

void draw(){
  initializeDraw();
  script();    
}

//****************************************************************************

void initializeDraw(){
  
  background(255);
  smooth();
  frameRate(fps);
  nSec = frameCount / fps;

}

//****************************************************************************

void script () {
  step1();
  step2();
  step3();
} 

//****************************************************************************

void step1(){
  if (step == 1) {
    if (mousePressed == true) {
      nodos[0].x = mouseX;
      nodos[0].y = mouseY;
      nodos[0].render();
    }
  } 
}

//****************************************************************************

void step2(){
  if (step == 2){
    nodos[0].render();
    if (mousePressed == true) {
      nodos[1].x = mouseX;
      nodos[1].y = mouseY;
      nodos[1].render();
    }
  }
}

//****************************************************************************

void step3(){
  if (step == 3){

    stroke(162);
    strokeWeight(3);
    line(nodos[0].x, nodos[0].y, nodos[1].x, nodos[1].y);

    nodos[0].render();
    nodos[1].render();

//    x = int(nodos[0].x + (nodos[1].x - nodos[0].x) / 100 * t);
//    y = int(nodos[0].y + (nodos[1].y - nodos[0].y) / 100 * t);

    x = myBezierX(t, int(nodos[0].x), int(nodos[1].x));  
    y = myBezierY(t, int(nodos[0].y), int(nodos[1].y));  
    
    stroke(0);
    fill(0);
    ellipse(x, y, 5, 5);

    stroke(255,0,0);
    strokeWeight(2);
    line(nodos[0].x, nodos[0].y, x, y);

      if (t < 100){
        t = t + 1;
        stepTime = nSec;
      } else if (nSec> stepTime + 1){
          t = 0;
      }  

  }
}

//****************************************************************************

void updateStep(){
  step = step + 1;
  stepTime = nSec; 
}

//****************************************************************************

int myBezierX(int t, int x0, int x1){
  return int(x0 + float(t)/100 * (x1 - x0));
} 

//*****************************************************************************

int myBezierY(int t, int y0, int y1){
  return int(y0 + float(t)/100 * (y1 - y0));
} 

