PFont f, f1, pixel;
float t, t0, fps, stepTime, nSec;
Point p[], q[], r[], s;
int step;
Nodo n1, n2;
boolean vis = true;
int numNodos;
Nodo[] nodos;
String numero;


//*****************************************************************************

void setup( )
{
  
  size(800, 600);
  fps = 50;
  
  t0 = 0;
  stepTime = nSec;

  f = createFont("Arial", 16,true);
  f1 = createFont("Arial", 10,true);
  
  numNodos = 4;
  
  pixel = loadFont("pixel.vlw");
  nodos = new Nodo[numNodos];
  textFont (pixel, 8);
  textAlign(CENTER);
  ellipseMode(CENTER);
  smooth();
  
  
  numero = nfs(0, 0); // transforme 'i' en un string con cero decimal
  nodos[0] = new Nodo(200,200, numero);

  numero = nfs(1, 0); // transforme 'i' en un string con cero decimal
  nodos[1] = new Nodo(300,300, numero);
  
  numero = nfs(2, 0); // transforme 'i' en un string con cero decimal
  nodos[2] = new Nodo(400,300, numero);
  
  numero = nfs(3, 0); // transforme 'i' en un string con cero decimal
  nodos[3] = new Nodo(500,300, numero);
  
  step = 1;

}

//*****************************************************************************

void draw(){
  initializeDraw();
  script();    

}

//****************************************************************************

void initializeDraw(){
  background(255);
  smooth();
  frameRate(fps);
  nSec = frameCount / fps;
}

//****************************************************************************

void script () {
  step1();
  step2();
  step3();
  step4();
  step5();
} 

//****************************************************************************

void step1(){
  if (step == 1) {
    if (mousePressed == true) {
      nodos[0].x = mouseX;
      nodos[0].y = mouseY;
      nodos[0].render();
    }
  } 
}

//****************************************************************************

void step2(){
  if (step == 2){
    nodos[0].render();
    if (mousePressed == true) {
      stroke(162);
      strokeWeight(3);
      nodos[1].x = mouseX;
      nodos[1].y = mouseY;
      line(nodos[0].x, nodos[0].y, nodos[1].x, nodos[1].y);
      nodos[1].render();
    }
  }
}

//****************************************************************************

void step3(){
  if (step == 3){
    line(nodos[0].x, nodos[0].y, nodos[1].x, nodos[1].y);
    nodos[0].render();
    nodos[1].render();
    stroke(162);
    strokeWeight(3);
    if (mousePressed == true) {
      stroke(162);
      strokeWeight(3);
      nodos[2].x = mouseX;
      nodos[2].y = mouseY;
      line(nodos[1].x, nodos[1].y, nodos[2].x, nodos[2].y);
      nodos[1].render();
      nodos[2].render();
    }
  }
}

//****************************************************************************

void step4(){
  if (step == 4){
    line(nodos[0].x, nodos[0].y, nodos[1].x, nodos[1].y);
    line(nodos[1].x, nodos[1].y, nodos[2].x, nodos[2].y);
    nodos[0].render();
    nodos[1].render();
    nodos[2].render();
    stroke(162);
    strokeWeight(3);
    if (mousePressed == true) {
      stroke(162);
      strokeWeight(3);
      nodos[3].x = mouseX;
      nodos[3].y = mouseY;
      line(nodos[2].x, nodos[2].y, nodos[3].x, nodos[3].y);
      nodos[1].render();
      nodos[2].render();
      nodos[3].render();
    }
  }
}

//****************************************************************************

void step5(){
  if (step == 5){

    stroke(162);
    strokeWeight(3);
    line(nodos[0].x, nodos[0].y, nodos[1].x, nodos[1].y);
    line(nodos[1].x, nodos[1].y, nodos[2].x, nodos[2].y);
    line(nodos[2].x, nodos[2].y, nodos[3].x, nodos[3].y);

    nodos[0].render();
    nodos[1].render();
    nodos[2].render();
    nodos[3].render();

    p = new Point[4];
    p[0] = new Point(nodos[0].x, nodos[0].y);
    p[1] = new Point(nodos[1].x, nodos[1].y);
    p[2] = new Point(nodos[2].x, nodos[2].y);
    p[3] = new Point(nodos[3].x, nodos[3].y);

  q = new Point[3];
  q[0] = new Point(myBezierX(t0, p[0].x, p[1].x),
                   myBezierY(t0, p[0].y, p[1].y));
  q[1] = new Point(myBezierX(t0, p[1].x, p[2].x),
                   myBezierY(t0, p[1].y, p[2].y));
  q[2] = new Point(myBezierX(t0, p[2].x, p[3].x),
                   myBezierY(t0, p[2].y, p[3].y));

  stroke(0,255,0);
  fill(0,255,0); // GREEN
  stroke(0,255,0); // GREEN
  ellipse(q[0].x, q[0].y, 5, 5);
  ellipse(q[1].x, q[1].y, 5, 5);
  strokeWeight(2);
  line(q[0].x, q[0].y, q[1].x, q[1].y);
  line(q[1].x, q[1].y, q[2].x, q[2].y);

  r = new Point[2];
  r[0] = new Point(myBezierX(t0, q[0].x, q[1].x), 
                  myBezierY(t0, q[0].y, q[1].y));  
  r[1] = new Point(myBezierX(t0, q[1].x, q[2].x), 
                   myBezierY(t0, q[1].y, q[2].y));  

  stroke(0,0,225);
  fill(0,0,255); // BLUE
  ellipse(r[0].x, r[0].y, 5, 5);
  ellipse(r[1].x, r[1].y, 5, 5);
  strokeWeight(2);
  line(r[0].x, r[0].y,r[1].x, r[1].y);
  
  s = new Point(myBezierX(t0, r[0].x, r[1].x), 
                myBezierY(t0, r[0].y, r[1].y));  
  
  stroke(0);
  fill(0);
  smooth();
  ellipse(s.x, s.y, 5, 5);
  strokeWeight(2);


  stroke(255,0,0);
  fill(255,0,0);
  smooth();
  
  t = 0;
  while(t <= t0){
    q[0] = new Point(myBezierX(t, p[0].x, p[1].x),
                     myBezierY(t, p[0].y, p[1].y));
    q[1] = new Point(myBezierX(t, p[1].x, p[2].x),
                     myBezierY(t, p[1].y, p[2].y));
    q[2] = new Point(myBezierX(t, p[2].x, p[3].x),
                     myBezierY(t, p[2].y, p[3].y));
    r[0] = new Point(myBezierX(t, q[0].x, q[1].x), 
                     myBezierY(t, q[0].y, q[1].y));  
    r[1] = new Point(myBezierX(t, q[1].x, q[2].x), 
                     myBezierY(t, q[1].y, q[2].y));  
    s = new Point(myBezierX(t, r[0].x, r[1].x), 
                  myBezierY(t, r[0].y, r[1].y));  
    smooth();
    ellipse(s.x, s.y, 0.3, 0.3);
    t = t + 0.3;

  }



  if (t0 < 100){
    t0 = t0 + 1;
    stepTime = nSec;
  } else if (nSec> stepTime + 1){
      t0 = 0;
  }  

  }
}
    
//*****************************************************************************

float myBezierX(float t, float x0, float x1){
  return x0 + t/100 * (x1 - x0);
} 

//*****************************************************************************

float myBezierY(float t, float y0, float y1){
  return y0 + t/100 * (y1 - y0);
} 

//****************************************************************************

void updateStep(){
  step = step + 1;
  stepTime = nSec; 
}



