class Swarm {
  float centerX;
  float centerY;
  float radius;
  int size;
  SwarmPoint[] points;

//----------------------------------------------------------------------------  
  
  Swarm (float newCenterX, float newCenterY, int newSize, float newRadius) {
     centerX = newCenterX;
     centerY = newCenterY;
     radius = newRadius;
     size = newSize;
     
     points = new SwarmPoint[size];
   
     for (int i = 0; i < size; i++) {
       
        float newAngle = random(TWO_PI);
        float newPointRadius = random(radius);
  
        points[i] = new SwarmPoint(centerX, centerY, radius,
                                   newAngle, newPointRadius); 

     }
          
  }
  
//----------------------------------------------------------------------------  
  
  void updatePositions () {
    for (int i = 0; i < size; i++) {
      points[i].x = centerX + points[i].pointRadius * cos(points[i].angle);
      points[i].y = centerY + points[i].pointRadius * sin(points[i].angle);

    }    
  }
  
//----------------------------------------------------------------------------  
  
  void showSwarm () {
    for (int i = 0; i < size; i++) {
      points[i].showPoint();
    }    
  }
  
//----------------------------------------------------------------------------  
  
}
