PFont f, f1;
int t;
int x, x0, x1, y0, y1;

void setup( )
{
  size(800, 600);
  background(255);
  smooth();
  
  stroke(0);
  strokeWeight(1);
  //  fill(#FF7040);

  x0 = 150;
  y0 = 300;
  x1 = 550;
  y1 = 300;

  ellipse(x0, y0, 5, 5);
  ellipse(x1, y1, 5, 5); 

  stroke(162);
  strokeWeight(2);

  line(x0, y0, x1, y1);

  t = 50;
  x = myBezierX(t, x0, x1);

  stroke(0);
  fill(0);
  ellipse(x, y0, 5, 5);

  stroke(255,0,0);
//  line(150, 300, x, 300);
  line(x0, y0, x, y0);

  f = createFont("Arial", 16,true);
  f1 = createFont("Arial", 10,true);
  
  fill(0);

  textFont(f);
  text("t = " + t, 320, 350);
  text("P" , 132, 300);
  textFont(f1);
  text("0" , 139, 303);
  textFont(f);
  text("P" , 556, 300);
  textFont(f1);
  text("1" , 563 , 303);

}

//*****************************************************************************

int myBezierX(int t, int x0, int x1){
  println("t/100 = " + float(t) / 100);
  return int(x0 + float(t)/100 * (x1 - x0));
} 

//*****************************************************************************

int myBezierY(int t, int y0, int y1){
  return int(x0 + float(t)/100 * (y1 - y0));
} 


