PFont f, f1;
int t;
int x, x0, x1, y0, y1;
float fps, nSec, stepTime;

//*****************************************************************************

void setup( )
{
  size(800, 600);
  fps = 50;

  
  t = 0;
  stepTime = nSec;

  f = createFont("Arial", 16,true);
  f1 = createFont("Arial", 10,true);
  
  x0 = 150;
  y0 = 300;
  x1 = 550;
  y1 = 300;

}

//*****************************************************************************

void draw(){
  
  background(255);
  smooth();
  frameRate(fps);
  nSec = frameCount / fps;

  stroke(0);
  strokeWeight(1);

//  ellipse(150, 300, 5, 5);
//  ellipse(550, 300, 5, 5); 
  ellipse(x0, y0, 5, 5);
  ellipse(x1, y1, 5, 5); 


  stroke(162);
  strokeWeight(2);

//  line(150, 300, 550, 300);
  line(x0, y0, x1, y1);

//  t = 50;
//  x = 150 + 400 / 100 * t;
  x = myBezierX(t, x0, x1);


  stroke(0);
  fill(0);
//  ellipse(x, 300, 5, 5);
  ellipse(x, y0, 5, 5);

  stroke(255,0,0);
//  line(150, 300, x, 300);
  line(x0, y0, x, y0);


  fill(0);

  textFont(f);
  text("t = " + t, 320, 350);
  text("P" , 132, 300);
  textFont(f1);
  text("0" , 139, 303);
  textFont(f);
  text("P" , 556, 300);
  textFont(f1);
  text("1" , 563 , 303);

  
  if (t < 100){
    t = t + 1;
    stepTime = nSec;
  } else if (nSec> stepTime + 1){
      t = 0;
  }  
  
    
}

//*****************************************************************************

int myBezierX(int t, int x0, int x1){
  return int(x0 + float(t)/100 * (x1 - x0));
} 

//*****************************************************************************

int myBezierY(int t, int y0, int y1){
  return int(y0 + float(t)/100 * (y1 - y0));
} 

