PFont f, f1, pixel;
float t, t0, fps, stepTime, nSec;
Point p[], q[], r;
int step;
Nodo n1, n2;
boolean vis = true;
int numNodos;
Nodo[] nodos;
String numero;


//*****************************************************************************

void setup( )
{
  
  size(800, 600);
  fps = 50;
  
  t0 = 0;
  stepTime = nSec;

  f = createFont("Arial", 16,true);
  f1 = createFont("Arial", 10,true);
  
  numNodos = 3;
  
  pixel = loadFont("pixel.vlw");
  nodos = new Nodo[numNodos];
  textFont (pixel, 8);
  textAlign(CENTER);
  ellipseMode(CENTER);
  smooth();
  
  
  numero = nfs(0, 0); // transforme 'i' en un string con cero decimal
  nodos[0] = new Nodo(200,200, numero);

  numero = nfs(1, 0); // transforme 'i' en un string con cero decimal
  nodos[1] = new Nodo(300,300, numero);
  
  numero = nfs(2, 0); // transforme 'i' en un string con cero decimal
  nodos[2] = new Nodo(400,300, numero);
  
  step = 1;


}

//*****************************************************************************

void draw(){
  initializeDraw();
  script();    

/*  
  background(255);
  smooth();
  frameRate(fps);
  nSec = frameCount / fps;

  stroke(0);
  strokeWeight(1);
  
  p = new Point[3];
  p[0] = new Point(150, 400);
  p[1] = new Point(300, 200);
  p[2] = new Point(550, 400);

  ellipse(p[0].x, p[0].y, 5, 5);
  ellipse(p[1].x, p[1].y, 5, 5);
  ellipse(p[2].x, p[2].y, 5, 5);
  
  fill(0);
  textFont(f);
  text("t = " + t0, 320, 450);

  text("P" , p[0].x - 19, p[0].y);
  textFont(f1);
  text("0" , p[0].x - 19 + 7, p[0].y + 3);

  textFont(f);
  text("P" , p[1].x, p[1].y - 10);
  textFont(f1);
  text("1" , p[1].x + 7, p[1].y - 10 + 3);

  textFont(f);
  text("P" , p[2].x + 12, p[2].y);
  textFont(f1);
  text("2" , p[2].x + 12 + 7, p[2].y + 3);


  stroke(162);
  strokeWeight(2);

  line(p[0].x, p[0].y, p[1].x, p[1].y);
  line(p[1].x, p[1].y, p[2].x, p[2].y);

  q = new Point[2];
  q[0] = new Point(myBezierX(t0, p[0].x, p[1].x),
                   myBezierY(t0, p[0].y, p[1].y));
  q[1] = new Point(myBezierX(t0, p[1].x, p[2].x),
                   myBezierY(t0, p[1].y, p[2].y));

  stroke(0);
  fill(0,255,0); // GREEN
  stroke(0,255,0); // GREEN
  ellipse(q[0].x, q[0].y, 5, 5);
  ellipse(q[1].x, q[1].y, 5, 5);
  line(q[0].x, q[0].y, q[1].x, q[1].y);
  
  r = new Point(myBezierX(t0, q[0].x, q[1].x), myBezierY(t0, q[0].y, q[1].y));  
  
  stroke(0);
  ellipse(r.x, r.y, 5, 5);

  stroke(255,0,0);
  fill(255,0,0);
  smooth();

  ellipse(r.x, r.y, 0.3, 0.3);

  t = 0;
  while(t <= t0){
    q[0].x = myBezierX(t, p[0].x, p[1].x);
    q[0].y = myBezierY(t, p[0].y, p[1].y);
    q[1].x = myBezierX(t, p[1].x, p[2].x);
    q[1].y = myBezierY(t, p[1].y, p[2].y);    
    smooth();
    ellipse(myBezierX(t, q[0].x, q[1].x),
            myBezierY(t, q[0].y, q[1].y),
            0.3, 0.3);
    q[0].x = myBezierX(t0, p[0].x, p[1].x);
    q[0].y = myBezierY(t0, p[0].y, p[1].y);
    q[1].x = myBezierX(t0, p[1].x, p[2].x);
    q[1].y = myBezierY(t0, p[1].y, p[2].y);                
    t = t + 0.3;
  }



  if (t0 < 100){
    t0 = t0 + 1;
    stepTime = nSec;
  } else if (nSec> stepTime + 1){
      t0 = 0;
  }  

  println("t0 = " + t0);
*/  
}

//****************************************************************************

void initializeDraw(){
  background(255);
  smooth();
  frameRate(fps);
  nSec = frameCount / fps;
}

//****************************************************************************

void script () {
  step1();
  step2();
  step3();
  step4();
} 

//****************************************************************************

void step1(){
  if (step == 1) {
    if (mousePressed == true) {
      nodos[0].x = mouseX;
      nodos[0].y = mouseY;
      nodos[0].render();
    }
  } 
}

//****************************************************************************

void step2(){
  if (step == 2){
    nodos[0].render();
    if (mousePressed == true) {
      stroke(162);
      strokeWeight(3);
      line(nodos[0].x, nodos[0].y, nodos[1].x, nodos[1].y);
      nodos[1].x = mouseX;
      nodos[1].y = mouseY;
      nodos[1].render();
    }
  }
}

//****************************************************************************

void step3(){
  if (step == 3){
    line(nodos[0].x, nodos[0].y, nodos[1].x, nodos[1].y);
    nodos[0].render();
    nodos[1].render();
    stroke(162);
    strokeWeight(3);
    if (mousePressed == true) {
      stroke(162);
      strokeWeight(3);
      line(nodos[1].x, nodos[1].y, nodos[2].x, nodos[2].y);
      nodos[2].x = mouseX;
      nodos[2].y = mouseY;
      nodos[1].render();
      nodos[2].render();
    }
  }
}

//****************************************************************************

void step4(){
  if (step == 4){

    stroke(162);
    strokeWeight(3);
    line(nodos[0].x, nodos[0].y, nodos[1].x, nodos[1].y);
    line(nodos[1].x, nodos[1].y, nodos[2].x, nodos[2].y);

    nodos[0].render();
    nodos[1].render();
    nodos[2].render();

    p = new Point[3];
    p[0] = new Point(nodos[0].x, nodos[0].y);
    p[1] = new Point(nodos[1].x, nodos[1].y);
    p[2] = new Point(nodos[2].x, nodos[2].y);


  q = new Point[2];
  q[0] = new Point(myBezierX(t0, p[0].x, p[1].x),
                   myBezierY(t0, p[0].y, p[1].y));
  q[1] = new Point(myBezierX(t0, p[1].x, p[2].x),
                   myBezierY(t0, p[1].y, p[2].y));

  stroke(0);
  fill(0,255,0); // GREEN
  stroke(0,255,0); // GREEN
  ellipse(q[0].x, q[0].y, 5, 5);
  ellipse(q[1].x, q[1].y, 5, 5);
  strokeWeight(2);
  line(q[0].x, q[0].y, q[1].x, q[1].y);
  
  r = new Point(myBezierX(t0, q[0].x, q[1].x), myBezierY(t0, q[0].y, q[1].y));  
  
  stroke(0);
/*
  ellipse(myBezierX(t0, q[0].x, q[1].x),
          myBezierY(t0, q[0].y, q[1].y),
          5, 5);
*/
  ellipse(r.x, r.y, 5, 5);

  stroke(255,0,0);
  fill(255,0,0);
  smooth();

  ellipse(r.x, r.y, 0.3, 0.3);
  strokeWeight(2);

  t = 0;
  while(t <= t0){
    q[0].x = myBezierX(t, p[0].x, p[1].x);
    q[0].y = myBezierY(t, p[0].y, p[1].y);
    q[1].x = myBezierX(t, p[1].x, p[2].x);
    q[1].y = myBezierY(t, p[1].y, p[2].y);    
    smooth();
    ellipse(myBezierX(t, q[0].x, q[1].x),
            myBezierY(t, q[0].y, q[1].y),
            0.3, 0.3);
    q[0].x = myBezierX(t0, p[0].x, p[1].x);
    q[0].y = myBezierY(t0, p[0].y, p[1].y);
    q[1].x = myBezierX(t0, p[1].x, p[2].x);
    q[1].y = myBezierY(t0, p[1].y, p[2].y);                
    t = t + 0.3;
  }



  if (t0 < 100){
    t0 = t0 + 1;
    stepTime = nSec;
  } else if (nSec> stepTime + 1){
      t0 = 0;
  }  


  }
}
    
//*****************************************************************************

float myBezierX(float t, float x0, float x1){
  return x0 + t/100 * (x1 - x0);
} 

//*****************************************************************************

float myBezierY(float t, float y0, float y1){
  return y0 + t/100 * (y1 - y0);
} 

//****************************************************************************

void updateStep(){
  step = step + 1;
  stepTime = nSec; 
}



